
import { Canvas, instantiate, Prefab, resources, Scene, UITransform, View, Widget } from 'cc';
import { _decorator, Component, Node, game, director, SceneAsset } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('TestMain')
export class TestMain extends Component {
    @property(Prefab) prefab!: Prefab
    @property(SceneAsset) scene!: SceneAsset

    onLoad() {
        let canvas = new Node("ROOT").addComponent(Canvas)
        canvas.alignCanvasWithScreen = true
        let transform = canvas.node.getComponent(UITransform)
        let size = View.instance.getFrameSize()
        transform?.setContentSize(size)
        canvas.node.setPosition(size.width * 0.5, size.height * 0.5)
        let widget = canvas.node.addComponent(Widget)
        widget.isAlignRight = widget.isAlignLeft = widget.isAlignTop = widget.isAlignBottom = true
        // Camera
        // let camera = new Node("camera").addComponent(Camera)
        // camera.priority = 0
        // camera.visibility = Layers.makeMaskExclude([Layers.BitMask.UI_2D, Layers.BitMask.DEFAULT])
        // console.error("visibility",camera.visibility)
        // canvas.cameraComponent = camera
        // canvas.node.addChild(camera.node)
        canvas.node.setSiblingIndex(10000)
        game.addPersistRootNode(canvas.node)

        let obj = instantiate(this.prefab)
        canvas.node.addChild(obj)
    }
    goTest() {
        director.runScene(this.scene)
        // director.runSceneImmediate(this.scene)
    }

}
